﻿//Почтовый клиент 2015(c)QuikLuaCSharp.ru
using System;
using System.ComponentModel;
using System.IO;
using System.IO.MemoryMappedFiles;
using System.Net;
using System.Net.Mail;
using System.Threading;
using System.Windows.Forms;

namespace Email
{
   public partial class Form1 : Form
   {
      public static SmtpClient Client;

      // Выделенная именованная память
      public static MemoryMappedFile EmailMemory;
      // Объекты для чтения из памяти
      public static StreamReader SR_EmailMemory;
      // Объекты для записи в память
      public static StreamWriter SW_EmailMemory;

      //КОНСТАНТЫ СОСТОЯНИЯ ПАМЯТИ
      const string QR = "_QR_"; // Память ожидает чтения Qlua (Qlua Read)
      const string QW = "_QW_"; // Память ожидает записи Qlua (Qlua Write)
      const string CR = "_CR_"; // Память ожидает чтения C# (C# Read)
      const string CW = "_CW_"; // Память ожидает записи C# (C# Write)        

      public static bool EmailRun = true; // Флаг работы приложения

      public static bool EmailSending = false; // Флаг, что идет отправка email

      public Form1()
      {
         InitializeComponent();

         // Создаст, или подключится к уже созданной памяти с таким именем
         EmailMemory = MemoryMappedFile.CreateOrOpen("EmailMemory", 4096, MemoryMappedFileAccess.ReadWrite);
         // Создает потоки для чтения
         SR_EmailMemory = new StreamReader(EmailMemory.CreateViewStream(), System.Text.Encoding.Default);
         // Создает потоки для записи
         SW_EmailMemory = new StreamWriter(EmailMemory.CreateViewStream(), System.Text.Encoding.Default);
         // Запускает функцию, которая в отдельном потоке ждет команды от QLua на отправку email
         GettingEmailInfo();  
      }

      //Считывает информацию из памяти "EmailMemory"
      public string GetEmailInfo()
      {
         string EmailInfo = "";

         //Ждет от DLL сообщения о готовности отправить email ("Q_READY")
         while(EmailRun)
         {
            // Встает в начало потока
            SR_EmailMemory.BaseStream.Seek(0, SeekOrigin.Begin);
            // Считывает все, что есть в памяти, обрезая нули и др. сервисные символы
            EmailInfo = SR_EmailMemory.ReadToEnd().Trim('\0', '\r', '\n');
            // Если пришло сообщение о готовности, выходит из цикла для дальнейших действий
            if (EmailInfo == "Q_READY") break;

            Thread.Sleep(10); // Пауза в 10 миллисекунд, чтобы не перегружать процессор
         }
         if (!EmailRun) return ""; // Если приложение завершается, выходит из функции, чтобы не задерживать процесс

         // Встает в начало потока
         SW_EmailMemory.BaseStream.Seek(0, SeekOrigin.Begin);
         // Очищает память, заполняя "нулевыми байтами"
         for (int i = 0; i < 4096; i++) SW_EmailMemory.Write("\0");
         // Очищает все буферы и вызывает запись всех данных буферов в основной поток
         SW_EmailMemory.Flush();
         // Встает в начало потока
         SW_EmailMemory.BaseStream.Seek(0, SeekOrigin.Begin);
         // Записывает в начало константу "_QW_", означающую, что память ожидает записи QLua
         SW_EmailMemory.Write(QW);
         // Очищает все буферы и вызывает запись всех данных буферов в основной поток
         SW_EmailMemory.Flush();

         // Выполняет цикл, пока память не готова для чтения C#
         while (EmailInfo.Length == 0 || EmailInfo.Length < 4 || (EmailInfo.Length >= 4 && EmailInfo.Substring(0, 4) != CR))
         {
            // Встает в начало потока
            SR_EmailMemory.BaseStream.Seek(0, SeekOrigin.Begin);
            // Считывает все, что есть в памяти, обрезая нули и др. сервисные символы
            EmailInfo = SR_EmailMemory.ReadToEnd().Trim('\0', '\r', '\n');

            Thread.Sleep(10); // Пауза в 10 миллисекунд, чтобы не перегружать процессор
            if (!EmailRun) return ""; // Если приложение завершается, выходит из функции, чтобы не задерживать процесс
         }
         if (!EmailRun) return ""; // Если приложение завершается, выходит из функции, чтобы не задерживать процесс

         // Встает в начало потока
         SW_EmailMemory.BaseStream.Seek(0, SeekOrigin.Begin);
         // Очищает память, заполняя "нулевыми байтами"
         for (int i = 0; i < 4096; i++) SW_EmailMemory.Write("\0");
         // Очищает все буферы и вызывает запись всех данных буферов в основной поток
         SW_EmailMemory.Flush();
         // Встает в начало потока
         SW_EmailMemory.BaseStream.Seek(0, SeekOrigin.Begin);
         // Записывает в начало константу "_CW_", означающую, что память ожидает записи C#
         SW_EmailMemory.Write(CW);
         // Очищает все буферы и вызывает запись всех данных буферов в основной поток
         SW_EmailMemory.Flush();

         // Возвращает то, что прочитано, без управляющей константы
         return EmailInfo.Substring(4);
      }

      // Функция постоянно читает данные из памяти "EmailMemory" при помощи функции GetEmailInfo
      public void GettingEmailInfo()
      {
         //Запускает функцию получения сервисной информации в отдельном потоке, чтобы приложение откликалось на действия пользователя
         //Чтобы остановить выполнение данного потока, нужно переменной "EmailRun" присвоить значение "false"
         new Thread(() => // Создает новый поток
         {
            string EmailInfo = "";
            string[] EmailInfoParts;

            //Постоянный цикл в отдельном потоке
            while (EmailRun)
            {
               if (EmailSending) {Thread.Sleep(1); continue; } // Если в данный момент выполняется отправка email-сообщения, то ждет завершения
               
               //Получает сервисную информацию из памяти, если ее нет, то ждет
               EmailInfo = GetEmailInfo();

               // Разделяет полученную строку на элементы
               EmailInfoParts = EmailInfo.Split(';');

               if (EmailInfoParts.Length > 1 && EmailInfoParts[0] == "EMAIL_INFO")// Если получены данные для отправки письма
               {                     
                  //Отправляет письмо
                  Send(EmailInfoParts);                  
               }

               //Чтобы процесс не "забивал" одно из ядер процессора на 100% нужна пауза в 10 миллисекунд
               Thread.Sleep(10);
            }
         }).Start(); // Запускает поток
      }

      // Отправляет email
      private void Send(string[] EmailInfoParts)
      {
         string Server = EmailInfoParts[1];     // Сервер
         string Login = EmailInfoParts[2];      // Логин
         string Password = EmailInfoParts[3];   // Пароль
         string To = EmailInfoParts[4];         // Кому
         string From = EmailInfoParts[5];       // От кого
         string Subject = EmailInfoParts[6];    // Тема
         string Body = EmailInfoParts[7];       // Текст письма
         string Attachment = (EmailInfoParts.Length == 9) ? EmailInfoParts[8] : ""; // Полный, или относительный путь к файлу вложения (если есть)

         EmailSending = true; // Устанавливает флаг, что началась отправка email, чтобы не инициировать новую

         try // Пытается выполнить блок кода
         {
            Client = new SmtpClient(Server);                      // Инициализирует новый экземпляр класса SmtpClient, который отправляет электронную почту с помощью указанного сервера SMTP
            MailAddress from = new MailAddress(From);             // От кого
            MailAddress to = new MailAddress(To);                 // Кому
            MailMessage message = new MailMessage(from, to);      // Содает объект сообщения
            message.Body = Body;                                  // Добавляет к сообщению текст
            message.BodyEncoding = System.Text.Encoding.UTF8;     // Устанавливает кодировку для текста сообщения
            message.Subject = Subject;                            // Добавляет к сообщению тему
            message.SubjectEncoding = System.Text.Encoding.UTF8;  // Устанавливает кодировку для темы сообщения

            if (Attachment != "") // Если есть вложение (файл)
            {
               Attachment data = new Attachment(Attachment);      // Создает объект вложения
               message.Attachments.Add(data);                     // Добавляет вложение к сообщению
            }

            // Инициализирует новый экземпляр класса NetworkCredential с заданными значениями пароля и имени пользователя
            Client.Credentials = new NetworkCredential(Login, Password);
            // Указывает, использует ли SmtpClient протокол SSL для шифрования подключения
            Client.EnableSsl = true;
            // Происходит после завершения асинхронной операции по отправке электронной почты (регистрирует функцию обратного вызова)
            Client.SendCompleted += new SendCompletedEventHandler(SendCompletedCallback);
            // Отправляет указанное сообщение SMTP-серверу для доставки в качестве асинхронной операции
            Client.SendAsync(message, null);
         }
         catch (Exception ex) // Если при выполнении блока кода после try произошла ошибка
         {
            SetMemoryResult("Ошибка отправки email: " + ex.ToString()); // Записывает в память результат отправки email
            EmailSending = false; // Сбрасывает флаг (процесс отправки завершен)
            // Отправляет сообщение QUIT на SMTP-сервер, правильно завершает TCP-подключение и освобождает все ресурсы, используемые текущим экземпляром класса SmtpClient
            Client.Dispose();
         }
      }

      //Функция записывает в память результат отправки email
      private static void SetMemoryResult(string Result)
      {
         string S = "";
         // Ожидает в цикле разрешения на запись в память
         while (EmailRun)
         {
            // Встает в начало потока
            SR_EmailMemory.BaseStream.Seek(0, SeekOrigin.Begin);
            // Считывает все, что есть в памяти
            S = SR_EmailMemory.ReadToEnd();
            // Если память ожидает записи C#, выходит из цикла while, иначе ждет 10 миллисекунд
            if (S.Length > 0 && S.Substring(0, 4) == CW) break; else Thread.Sleep(10);
         }

         // Встает в начало потока
         SW_EmailMemory.BaseStream.Seek(0, SeekOrigin.Begin);
         // Очищает память, заполняя "нулевыми байтами"
         for (int i = 0; i < 4096; i++) SW_EmailMemory.Write("\0");
         // Очищает все буферы и вызывает запись всех данных буферов в основной поток
         SW_EmailMemory.Flush();
         // Встает в начало потока
         SW_EmailMemory.BaseStream.Seek(0, SeekOrigin.Begin);
         // Записывает в начало константу "_QR_", означающую, что память ожидает чтения QLua и далее записывает саму команду
         SW_EmailMemory.Write(QR + Result);
         // Очищает все буферы и вызывает запись всех данных буферов в основной поток
         SW_EmailMemory.Flush();
      }

      // Функция вызывается по окончанию асинхронной отправки почтового сообщения
      private static void SendCompletedCallback(object sender, AsyncCompletedEventArgs e)
      {
         if (e.Error != null) // Если произошла ошибка
         {
            SetMemoryResult("Ошибка отправки email: " + e.Error.ToString());  // Записывает в память результат отправки email
            EmailSending = false; // Сбрасывает флаг (процесс отправки завершен)
            // Отправляет сообщение QUIT на SMTP-сервер, правильно завершает TCP-подключение и освобождает все ресурсы, используемые текущим экземпляром   класса SmtpClient
            Client.Dispose();
         }
         else // Отправка прошла без ошибок
         {
            SetMemoryResult("OK");  // Записывает в память результат отправки email
            EmailSending = false; // Сбрасывает флаг (процесс отправки завершен)
            // Отправляет сообщение QUIT на SMTP-сервер, правильно завершает TCP-подключение и освобождает все ресурсы, используемые текущим экземпляром   класса SmtpClient
            Client.Dispose();
         }
      }

      // Функция вызывается при закрытии данного приложения
      private void Form1_FormClosing(object sender, FormClosingEventArgs e)
      {
         notifyIcon1.Visible = false;  // Не отображать иконку
         EmailRun = false;             // Сбрасывает флаг работы приложения, чтобы завершился отдельный поток
      }

      // Функция вызывается при изменении размеров формы, следовательно, и при сворачивании и разворачивании
      private void Form1_Resize(object sender, EventArgs e)
      {
         if (WindowState == FormWindowState.Minimized) // Если форма свернута
         {
            Hide();                       // Скрывает форму
            notifyIcon1.Visible = true;   // Отображает иконку в области уведомлений
         }
      }

      // Функция вызывается при клике в контекстном меню, которое появляется при клике правой кнопкой мыши по иконке
      private void contextMenuStrip1_ItemClicked(object sender, ToolStripItemClickedEventArgs e)
      {
         if (e.ClickedItem.Text == "Закрыть") // Если клик по пункту "Закрыть"
         {
            Application.Exit();  // Закрывает приложение
            EmailRun = false;    // Сбрасывает флаг работы приложения, чтобы завершился отдельный поток
         }
      }
   }
}