//SenderEmail.cpp (c)QuikLuaCSharp.ru

#include <windows.h>    //        Windows
#include <thread>       //      
#include <tlhelp32.h>   //        


//===   Lua  ============================================================================//
#define LUA_LIB
#define LUA_BUILD_AS_DLL

//===   LUA ===================================================================================//
extern "C" {
#include "Lua\lauxlib.h"
#include "Lua\lua.h"
}

//===       =====================================================//
//       Email
TCHAR EmailMemory[] = TEXT("EmailMemory");
// ,         
HANDLE hFileMapEmail = CreateFileMapping(INVALID_HANDLE_VALUE, NULL, PAGE_READWRITE, 0, 4096, EmailMemory);

//  
const char *QR = "_QR_"; //    Qlua (Qlua Read)
const char *QW = "_QW_"; //    Qlua (Qlua Write)
const char *CR = "_CR_"; //    C# (C# Read)
const char *CW = "_CW_"; //    C# (C# Write)

volatile PBYTE pb = NULL; //     

TCHAR szPath[] = TEXT("Email.exe"); //   
STARTUPINFO si; //     
PROCESS_INFORMATION pi; //

bool SMTPclientWasRunning = false; // ,       ,      

//      ()   
bool IsProcessRun(const char * const processName)
{
   HANDLE hSnapshot = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);

   PROCESSENTRY32 pe;
   pe.dwSize = sizeof(PROCESSENTRY32);
   Process32First(hSnapshot, &pe);

   while (1) {
      if (strcmp(pe.szExeFile, processName) == 0) return true;
      if (!Process32Next(hSnapshot, &pe)) return false;
   }
}

//===     DLL ==========================================================================//
BOOL APIENTRY DllMain(HANDLE hModule, DWORD  fdwReason, LPVOID lpReserved)
{   
   //      fdwReason,   DllMain      
   switch (fdwReason)
   {
      case DLL_PROCESS_ATTACH:  //  DLL 
         //               
         if (!IsProcessRun("Email.exe"))
         {
            //  
            memset(&si, 0, sizeof(si));
            si.cb = sizeof(si);
            memset(&pi, 0, sizeof(pi));
            CreateProcess(NULL, szPath, NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi);
         }
         else
         {
            SMTPclientWasRunning = true; // ,       (   DLL)
         }
         return TRUE;
      case DLL_PROCESS_DETACH: //  DLL
         //       DLL
         if (!SMTPclientWasRunning)
         {
            //  
            TerminateProcess(pi.hProcess, 0);
            CloseHandle(pi.hProcess);
            CloseHandle(pi.hThread);
         }
         break;
      case DLL_THREAD_ATTACH: //   
         break;
      case DLL_THREAD_DETACH: //  
         break;
   }
   
   return TRUE;
}

//===   ==================================================================================//

//   
static bool QluaReadReady() //    Qlua (Qlua Read)
{
   if (pb[0] == '_' && pb[1] == 'Q' && pb[2] == 'R' && pb[3] == '_') return true;
   return false;
}
static bool QluaWriteReady() //    Qlua (Qlua Write)
{
   if (pb[0] == '_' && pb[1] == 'Q' && pb[2] == 'W' && pb[3] == '_') return true;
   return false;
}

//   "EmailMemory"    10 ,      email  C#,
//    QLua  EmailResult(),     
static int WaitingEmailResult(lua_State *L)
{
   lua_getglobal(L, "EmailResult"); //   Lua         
   if (lua_isfunction(L, -1)) //     
   {
      int callbackRef = luaL_ref(L, LUA_REGISTRYINDEX); //       () Lua 
      // ,  C#      email (    Qlua)
      while (!QluaReadReady()) { Sleep(10); } //   10   
      lua_rawgeti(L, LUA_REGISTRYINDEX, callbackRef); //     Lua        
      if (lua_isfunction(L, -1)) //     
      {
         lua_pushstring(L, (char*)(pb + 4)); //  Lua-   (  )
         lua_call(L, 1, 1); //     QLua,    1  (L - , 1 -   , 1 -   (,   ))
      }
      // 
      for (int i = 0; i < 4096; i++)pb[i] = '\0';
      //   "_QW_",   ,     QLua
      memcpy(pb, QW, 4);     
   }
   // 
   UnmapViewOfFile(pb);
   
   return (0); //  
}

//===  ,   LUA ====================================================================//

//   Email      C#
static int forLua_SendEmail(lua_State *L)
{    
   //    
   if (hFileMapEmail)
   {
      //   ()   / 
      pb = (PBYTE)(MapViewOfFile(hFileMapEmail, FILE_MAP_READ | FILE_MAP_WRITE, 0, 0, 4096));
      //   
      if (pb != NULL)
      {
         lua_getglobal(L, "EmailResult"); //   Lua         
         int callbackRef = luaL_ref(L, LUA_REGISTRYINDEX); //       () Lua

         // 
         for (int i = 0; i < 4096; i++)pb[i] = '\0';
         //  C#    
         memcpy(pb, "Q_READY", 7);
         //   C#   3- 
         //    ,    
         unsigned long long TickCount = GetTickCount();
         while (true)
         {
            //     C# (  "_QW_")
            if (QluaWriteReady())
            {
               break;//     
            }
            else
            {
               // 
               if (GetTickCount() - TickCount >= 3000)
               {
                  // 
                  for (int i = 0; i < 4096; i++)pb[i] = '\0';
                  //   
                  lua_rawgeti(L, LUA_REGISTRYINDEX, callbackRef); //     Lua        
                  lua_pushstring(L, ":     !!!"); //  Lua-  
                  lua_call(L, 1, 0); //     QLua,    1  (L - , 1 -   , 0 -   ))
                  
                  return (0);//  
               }
            }

            Sleep(1); //  1 
         }
         //   Lua-  Email-      
         char EmailInfo[4096] = "EMAIL_INFO;";
         strcat(EmailInfo, lua_tostring(L, 1)); //SMTP 
         strcat(EmailInfo, ";");
         strcat(EmailInfo, lua_tostring(L, 2)); // 
         strcat(EmailInfo, ";");
         strcat(EmailInfo, lua_tostring(L, 3)); // 
         strcat(EmailInfo, ";");
         strcat(EmailInfo, lua_tostring(L, 4)); //Email 
         strcat(EmailInfo, ";");
         strcat(EmailInfo, lua_tostring(L, 5)); //Email 
         strcat(EmailInfo, ";");
         strcat(EmailInfo, lua_tostring(L, 6)); // 
         strcat(EmailInfo, ";");
         strcat(EmailInfo, lua_tostring(L, 7)); // 
         if (lua_isstring(L, 8) && lua_tostring(L, 8) != "") //    (  )
         {
            strcat(EmailInfo, ";");
            strcat(EmailInfo, lua_tostring(L, 8)); //   
         }

         int Size = 0;
         //     
         for (int i = 0; i < 4096; i++)
         {
            if (EmailInfo[i] == 0)break;
            Size++;
         }
         memcpy(pb + 4, EmailInfo, Size);//    ,   5-          
         memcpy(pb, CR, 4);//   "_CR_",   ,       C#

         std::thread thr(WaitingEmailResult, L); //     
         thr.detach(); //    ,   ""
      }
   }
   return(0);
}

//===    dll ,    ""  Lua ================================//
static struct luaL_reg ls_lib[] = {
   { "SendEmail", forLua_SendEmail },
   { NULL, NULL }
};

//===   ,    Lua ==================================================//
extern "C" LUALIB_API int luaopen_SenderEmail(lua_State *L) {
   luaL_openlib(L, "SenderEmail", ls_lib, 0);
   return 0;
}
